﻿package 
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	
	import flash.display.Bitmap;
	import flash.display.BitmapData;

	public class Fourmiz extends Sprite
	{
		private var o:Array = new Array();
		private var i:Number=0;
		
		private var drawer:Sprite;
		private var bitData:BitmapData;
		private var ground:Bitmap;
		
		private var vortex : Vortex;
		private var aktiv :Boolean;
		
		public var balls:Array;
		public var obj:Object;
		private var ax:Number;
		private var ay:Number;
		private var bx:Number;
		private var by:Number;
		
		private var speed:Number;
		private var anglX:Number;
		private var anglY:Number;
		private var alt:Number;
		
		public function Fourmiz()
		{
			addEventListener(Event.ADDED_TO_STAGE, addedHandler);
		}
		
		private function addedHandler(e:Event):void
		{
			
			balls=new Array;
			
			///////////////////////////////////////////////////////////////////////BITMAP
					
			bitData = new BitmapData(stage.stageWidth,stage.stageHeight,true,0x000000);
			ground = new Bitmap(bitData);
			addChildAt(ground,0);
			drawer = new Sprite();
			
			stage.addEventListener(MouseEvent.MOUSE_DOWN, downHandler);
			stage.addEventListener(MouseEvent.MOUSE_UP, upHandler);
			
			//////////////////////////////////////////////////////////////////////SETTINGS
			var reg:Number = .008;
			speed = 3;
			anglX = Math.sin(reg) - reg*2;
			anglY = Math.sin(reg*2) - reg*4;
			//////////////////////ON_KIFF_LES_SETTINGS////////////////////////////////////
			
		}
		
		private function downHandler(e:MouseEvent){

			removeEventListener(Event.ENTER_FRAME, enterHandler);
			
			bx = mouseX;
			by = mouseY;
			
			///
			addEventListener(Event.ENTER_FRAME, vortexHandler);
			aktiv = true;
			
			vortex = new Vortex();
			vortex.x = mouseX;
			vortex.y = mouseY;
			addChild(vortex);
			///

		}
		
		private function upHandler(e:MouseEvent){
			
			///
			removeEventListener(Event.ENTER_FRAME, vortexHandler);
			aktiv = false;
			///
			
			ax = vortex.x;
			ay = vortex.y;

			obj = {"x1":ax, "y1":ay, "x2":bx, "y2":by};
			balls.push(obj);
			
			addEventListener(Event.ENTER_FRAME, enterHandler);
			drawer.graphics.clear();
			i=0;
			
		}
		
		private function vortexHandler(e:Event):void
		{
			if (aktiv == true){
			vortex.x = mouseX;
			vortex.y = mouseY;
			}
		}
		
		private function enterHandler(e:Event):void
		{
			
			alt = Math.random() * 200 - 400;
			
			var dx:Number = balls[balls.length-1].x1 - balls[balls.length-1].x2;
			var dy:Number = balls[balls.length-1].y1 - balls[balls.length-1].y2;
			var dist:Number = Math.sqrt(Math.pow(dx,2) + Math.pow(dy,2))
			var angle:Number = 180 / Math.PI * Math.atan2(dy,dx) + 180;
			
			drawer.graphics.clear();
			drawer.graphics.lineStyle(.1,0x000000,.2);
			o[i++] = [balls[balls.length-1].x1, balls[balls.length-1].y1, anglX, anglY];
			
			for each(var p in o)
			{
				
				drawer.graphics.moveTo ( p[0],p[1] );
				
				drawer.graphics.lineTo ( p[0] += speed * (Math.sin((p[1] * p[2] * dx) / alt)), p[1] += speed * (Math.sin((p[0] * p[3] * dy) / alt)) );
				
			}
			i%=5000;
			
			bitData.draw(drawer);
			
		}
		
		///////////////////////////////
	}
}